#define GLUT_DISABLE_ATEXIT_HACK 
#include <windows.h>

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <GL/glaux.h>

GLuint	texture[1];
GLfloat	xrot;
GLfloat	yrot;
GLfloat	zrot;

void LoadTextures()
{
	AUX_RGBImageRec *TextureImage[1];
	memset(TextureImage,0,sizeof(void *)*1);
	
    TextureImage[0]=auxDIBImageLoad("Textures/metal.bmp");

	glGenTextures(1, &texture[0]);
	glBindTexture(GL_TEXTURE_2D, texture[0]);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

	gluBuild2DMipmaps(GL_TEXTURE_2D, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);

   	free(TextureImage[0]->data);
	free(TextureImage[0]);
}

void SceneIdle(void)
{
	xrot+=0.1f;
	yrot+=0.1f;
	zrot+=0.1f;
	glutPostRedisplay();
}

void RenderScene(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	glClearColor(0.0f, 0.0f, 0.0f, 1.0f );
	//glTranslatef(0.0f,0.0f,1.0f);
	glRotatef(xrot,1.0f,0.0f,0.0f);
	glRotatef(yrot,0.0f,1.0f,0.0f);
	glRotatef(zrot,0.0f,0.0f,1.0f);

	glBindTexture(GL_TEXTURE_2D, texture[0]);

	glBegin(GL_QUADS);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-.5f, -.5f,  .5f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( .5f, -.5f,  .5f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( .5f,  .5f,  .5f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-.5f,  .5f,  .5f);

		glTexCoord2f(1.0f, 0.0f); glVertex3f(-.5f, -.5f, -.5f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-.5f,  .5f, -.5f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( .5f,  .5f, -.5f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( .5f, -.5f, -.5f);

		glTexCoord2f(0.0f, 1.0f); glVertex3f(-.5f,  .5f, -.5f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f(-.5f,  .5f,  .5f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f( .5f,  .5f,  .5f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( .5f,  .5f, -.5f);

		glTexCoord2f(1.0f, 1.0f); glVertex3f(-.5f, -.5f, -.5f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( .5f, -.5f, -.5f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( .5f, -.5f,  .5f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-.5f, -.5f,  .5f);

		glTexCoord2f(1.0f, 0.0f); glVertex3f( .5f, -.5f, -.5f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f( .5f,  .5f, -.5f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f( .5f,  .5f,  .5f);
		glTexCoord2f(0.0f, 0.0f); glVertex3f( .5f, -.5f,  .5f);

		glTexCoord2f(0.0f, 0.0f); glVertex3f(-.5f, -.5f, -.5f);
		glTexCoord2f(1.0f, 0.0f); glVertex3f(-.5f, -.5f,  .5f);
		glTexCoord2f(1.0f, 1.0f); glVertex3f(-.5f,  .5f,  .5f);
		glTexCoord2f(0.0f, 1.0f); glVertex3f(-.5f,  .5f, -.5f);
	glEnd();

    glutSwapBuffers();
}

int main(int argc, char* argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutCreateWindow("Pelda09");
	glutDisplayFunc(RenderScene);
	glutIdleFunc(SceneIdle);
	glDisable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	glEnable(GL_TEXTURE_2D);

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);

	gluPerspective(45.0f,4/3,0.1f,100.0f);
	LoadTextures();	
	glutMainLoop();
	return 0;
}
