unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ToolWin, ComCtrls, ExtCtrls, Buttons, StdCtrls, FileCtrl, ImgList, jpeg, IniFiles,
  Menus;

type
  TForm1 = class(TForm)
    ToolBar1: TToolBar;
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Panel3: TPanel;
    Splitter2: TSplitter;
    Panel4: TPanel;
    SpeedButton1: TSpeedButton;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FilterComboBox1: TFilterComboBox;
    FileListBox1: TFileListBox;
    StatusBar1: TStatusBar;
    ImageList1: TImageList;
    ToolButton1: TToolButton;
		ToolButton2: TToolButton;
		ToolButton3: TToolButton;
		PopupMenu1: TPopupMenu;
		NewKedvenc: TMenuItem;
		N1: TMenuItem;
    ToolButton4: TToolButton;
    UpDown1: TUpDown;
    ToolButton5: TToolButton;
    Timer1: TTimer;
    PopupMenu2: TPopupMenu;
    FileDelete: TMenuItem;
		procedure FormCreate(Sender: TObject);
		procedure ToolButton1Click(Sender: TObject);
		procedure FileListBox1Click(Sender: TObject);
		procedure FormClose(Sender: TObject; var Action: TCloseAction);
		procedure ToolButton3Click(Sender: TObject);
		procedure NewKedvencClick(Sender: TObject);
		procedure KedvencClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FileDeleteClick(Sender: TObject);
	private
		{ Private declarations }
		FileName: string;
    DeleteConfirm: Boolean;
		procedure FileOpen(PictureName: string);
		procedure StatusBar(Sender: TObject);
		procedure PictureStretch;
		procedure RefreshImage;
		procedure AddKedvenc(s: string);
	public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function GyorsitoLe(s: string): string;
var i: integer;
begin
	result:=s;
	i:=Pos('&',s);
	if i>0 then
		result:=Copy(s,1,i-1)+Copy(s,i+1,Length(s));
end;


function GetExt(s: string): string;
begin
	// Visszaadja a fjl kiterjesztst!
	result:=Uppercase(ExtractFileExt(s));
end;  


procedure TForm1.FormCreate(Sender: TObject);
var Ini: TIniFile;
		sz: string;
		db,i: integer;
begin
  DeleteConfirm:=True;				// Fjl trlsre rkrdezzen e ?
	FileName:='';
	FileListBox1.Mask:=FilterComboBox1.Mask;
  // Belltsok visszatltse
  Ini:=TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));

  // Ablak poziciojnak visszatltse
  Left:=Ini.ReadInteger('Form','Left',Left);
  Top:=Ini.ReadInteger('Form','Top',Top);
  Width:=Ini.ReadInteger('Form','Width',Width);
  Height:=Ini.ReadInteger('Form','Height',Height);
  WindowState:=TWindowState(Ini.ReadInteger('Form','State',ord(WindowState)));

  // Az utoljra hasznlt alknyvtr!!!
  DriveComboBox1.Drive:=Char(Ini.ReadInteger('Path','DriveComboBox1',ord(DriveComboBox1.Drive)));
  sz:=Ini.ReadString('Path','DirectoryListBox1',DirectoryListBox1.Directory);
  if DirectoryExists(sz) then
	  DirectoryListBox1.Directory:=sz;

  // Kp kicsinyts visszatltse
	ToolButton3.Down:=Ini.ReadBool('Params','ToolButton3',ToolButton3.Down);

  // Kedvencek betltse!!!
	db:=Ini.ReadInteger('Kedvenc','Count',0);
	for i:=0 to db-1 do
		begin
		sz:=Ini.ReadString('Kedvenc','Kedvenc'+IntToStr(i),'');
		if sz<>'' then
			AddKedvenc(sz);
		end;
  // Bemutat rtkeinek betltse  
	Timer1.Interval:=Ini.ReadInteger('Timer','Interval',Timer1.Interval);
	UpDown1.Position:=Ini.ReadInteger('UpDown','Position',UpDown1.Position);
	Ini.Free;
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
	Close;
end;


procedure TForm1.PictureStretch;
var R: TRect;
		w,h: double;
begin
			// Kp ablak mrethez van igaztva!!!
			if (ToolButton3.Down) and (FileName<>'') then
				begin
				// R:=ScrollBox1.ClientRect;			// Megnzzk, hogy nem nylik e valamelyik oldal ki!!!
				Image1.Align:=alNone;
				R:=Rect(0,0,ScrollBox1.Width-4,ScrollBox1.Height-4);
				if (Image1.Picture.Width>R.Right) or (Image1.Picture.Height>R.Bottom) then
					begin
					w:=Image1.Picture.Width/R.Right;		// A szlessg arnya!!
					h:=Image1.Picture.Height/R.Bottom;	// A magassg arnya!!
					// A nagyobb arnnyal kell tmretezni az ablakot!
					if h>w then
						w:=h;
					// Arnyok tlltsa
					ScrollBox1.HorzScrollBar.Range:=round(Image1.Picture.Width/w);
					Image1.Width:=ScrollBox1.HorzScrollBar.Range;
					ScrollBox1.VertScrollBar.Range:=round(Image1.Picture.Height/w);
					Image1.Height:=ScrollBox1.VertScrollBar.Range;
					Image1.Stretch:=True;
					end
				else
					begin
					Image1.Width:=Image1.Picture.Width;
					Image1.Height:=Image1.Picture.Height;
					end;
				// Rakjuk az ablak kzepre a kpet!!!
				Image1.Left:=(R.Right-Image1.Width) div 2;
				Image1.Top:=(R.Bottom-Image1.Height) div 2;
				end;
end;


procedure TForm1.FileOpen(PictureName: string);
var s: string;
begin
		if Uppercase(FileName)=Uppercase(PictureName) then		// Mr be van tltve, nem kell!!
			exit;
		s:=GetExt(PictureName);
		try
		FileName:=PictureName;
		if FileExists(FileName) then
			begin
      Image1.Stretch:=ToolButton3.Down;
			Image1.Align:=alNone;
			Screen.Cursor:=crHourGlass;
			Image1.Picture.LoadFromFile(FileName);
			// lltsuk be a mreteket
			ScrollBox1.HorzScrollBar.Position:=0;
			ScrollBox1.HorzScrollBar.Range:=Image1.Picture.Width;
			ScrollBox1.VertScrollBar.Position:=0;
			ScrollBox1.VertScrollBar.Range:=Image1.Picture.Height;
			Image1.Align:=alClient;

			// Kp ablak mrethez van igaztva!!!
			if ToolButton3.Down then
				PictureStretch;
        
			StatusBar(nil);
			end;
		except
		end;
		Screen.Cursor:=crDefault;
end;

procedure TForm1.StatusBar(Sender: TObject);
begin
	StatusBar1.Panels.BeginUpdate;
  if Image1.Picture.Graphic.Empty then
		StatusBar1.Panels[0].Text:=''
	else
		begin
		StatusBar1.Panels[0].Text:='Mret: '+IntToStr(Image1.Picture.Width)+' x '+IntToStr(Image1.Picture.Height);
		// StatusBar1.Panels[3].Text:='Kp: '+IntToStr(SpinEdit1.Value)+' x '+IntToStr(Image1.Picture.Width div SpinEdit1.Value)+' x '+IntToStr(Image1.Picture.Height);
		end;
	StatusBar1.Panels[4].Text:=FileName;
	StatusBar1.Panels.EndUpdate;
end;


procedure TForm1.FileListBox1Click(Sender: TObject);
begin
	FileOpen(FileListBox1.FileName);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var Ini: TIniFile;
		i: integer;
		sz: string;
begin
  Ini:=TIniFile.Create(ChangeFileExt(Application.ExeName,'.ini'));

  // Ablak poziciojnak visszatltse
  Ini.WriteInteger('Form','State',ord(WindowState));
  WindowState:=wsNormal;
  Ini.WriteInteger('Form','Left',Left);
  Ini.WriteInteger('Form','Top',Top);
  Ini.WriteInteger('Form','Width',Width);
  Ini.WriteInteger('Form','Height',Height);
  
  // Az utoljra hasznlt alknyvtr mentse
	Ini.WriteInteger('Path','DriveComboBox1',ord(DriveComboBox1.Drive));
	Ini.WriteString('Path','DirectoryListBox1',DirectoryListBox1.Directory);

  // Kp kicsinyts elmentse
  Ini.WriteBool('Params','ToolButton3',ToolButton3.Down);

	// Kedvencek elmentse
	Ini.WriteInteger('Kedvenc','Count',PopupMenu1.Items.Count-2);
	for i:=2 to PopupMenu1.Items.Count-1 do
		begin
		sz:=GyorsitoLe(PopupMenu1.Items[i].Caption);
		Ini.WriteString('Kedvenc','Kedvenc'+IntToStr(i-2),sz);
		end;
  // Bemutat paramtereinek mentse
	Ini.WriteInteger('Timer','Interval',Timer1.Interval);
	Ini.WriteInteger('UpDown','Position',UpDown1.Position);
  
  Ini.Free;
end;

procedure TForm1.ToolButton3Click(Sender: TObject);
begin
	// Fel kell frissteni a kpet!!
  RefreshImage;
end;

procedure TForm1.RefreshImage;
var s: string;
begin
	if FileName<>'' then
  	begin
    s:=FileName;
    FileName:='';
		FileOpen(s);
		end;
end;


procedure TForm1.KedvencClick(Sender: TObject);
var s: string;
begin
	// Kedvenc kivlasztsa
  s:=GyorsitoLe(TMenuItem(Sender).Caption);
  if DirectoryExists(s) then
	  DirectoryListBox1.Directory:=s;
end;


procedure TForm1.AddKedvenc(s: string);
var TM: TMenuItem;
		sz,z: string;
		i: integer;
begin
	// Megnzzk, hogy nincs e mg ilyen kedvenc
	z:=Uppercase(s);				// Csupa nagybet!
	for i:=2 to PopupMenu1.Items.Count-1 do
		begin
		sz:=Uppercase(GyorsitoLe(PopupMenu1.Items[i].Caption));
		if z=sz then					// Mr van ilyen, nem szabad hozzadni!!!
			exit;
		end;
	// Hozzads a kedvencekhez!!!
	TM:=TMenuItem.Create(Self);
	TM.Caption:=s;
	TM.OnClick:=KedvencClick;
	PopupMenu1.Items.Add(TM);
end;



procedure TForm1.NewKedvencClick(Sender: TObject);
begin
	// Hozzads a kedvencekhez!!!
  AddKedvenc(DirectoryListBox1.Directory);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var TB: TSpeedbutton;
		P: TPoint;
begin
	// A popupmenu1 (Kedvencek) meghvsa
	TB:=TSpeedbutton(Sender);
	P:=Point(TB.Left,TB.Top+TB.Height);
	P:=TB.ClientToScreen(P);
	PopupMenu1.Popup(P.X,P.Y);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
	// Kp lptets
	Timer1.Enabled:=False;
	if FileListBox1.ItemIndex+1>=FileListBox1.Items.Count then
		begin
		// Timert le kell lltani, s megsznettni a lejtszst!!!
		ToolButton4.Down:=False;
		exit;
		end;
	// Lptets!
	FileListBox1.ItemIndex:=FileListBox1.ItemIndex+1;
	FileListBox1Click(nil);								// j fjl megjelentse
	Timer1.Enabled:=True;
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
	Timer1.Enabled:=ToolButton4.Down;
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
	// Id lptetse fel-le a bemutathoz!!!
	if Button=btNext then
		Timer1.Interval:=Timer1.Interval-100
	else
		Timer1.Interval:=Timer1.Interval+100;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
	// Lejtszs kikapcsolsa az ESC letsre!
	if (Key=#27) and (ToolButton4.Down) then
		begin
		Key:=#0;
		Timer1.Enabled:=False;
		ToolButton4.Down:=False;
		end;
end;

procedure TForm1.FileDeleteClick(Sender: TObject);
var i: integer;
begin
	// A kivlasztott fjl trlse
  if FileListBox1.ItemIndex>-1 then		// Van kijellt fjl!!!
  	begin
		if (not DeleteConfirm) or (MessageDlg('Fjl trls:'+#13+FileListBox1.FileName+#13+'Biztosan trljem?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
    	begin
      if DeleteFile(FileListBox1.FileName) then
      	begin
        i:=FileListBox1.ItemIndex;
        FileListBox1.Items.Delete(i);
        if i<FileListBox1.Items.Count then
        	FileListBox1.ItemIndex:=i
        else
        	FileListBox1.ItemIndex:=FileListBox1.Items.COunt-1;
        // Megjelents
        FileListBox1Click(nil);  
        end;
      end;
	  end;
end;

end.
