unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    GroupBox2: TGroupBox;
    ListBox2: TListBox;
    SrvType: TLabel;
    SrvStart: TLabel;
    ErrorCtrl: TLabel;
    BinPath: TLabel;
    GroupName: TLabel;
    GroupID: TLabel;
    AccountName: TLabel;
    DispName: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses WinSvc;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var
  scHandle : SC_HANDLE;

  st : TEnumServiceStatus;
  Buffer : array of TEnumServiceStatus;
  NumNeed, NeedBytes, Ret, Resume, ErrorCode : Cardinal;
  i : integer;
  Success : BOOL;
begin
  scHandle := OpenSCManager('',nil,SC_MANAGER_ALL_ACCESS);
  if scHandle = 0 then
    begin
      MessageDlg(SysErrorMessage(GetLastError),mtError,[mbOK],0);
      exit;
    end;

  ListBox1.Items.Clear;
  try
    Ret := 0;
    NeedBytes := 0;
    Resume := 0;   // Amikor elszr hvjuk az EnumServicesStatus-t, ezt 0-ra kell lltani

    Success := EnumServicesStatus(scHandle,SERVICE_WIN32,SERVICE_STATE_ALL,st,0,NeedBytes,Ret,Resume);
    ErrorCode := GetLastError;

    // Normlis esetben ez ErrorCode ERROR_MORE_DATA lesz, mivel 0 hossz tmbt adtunk t neki
    if ErrorCode = ERROR_MORE_DATA then
      begin
        // Kiszmoljuk, hogy mennyi szolgltatsnak kell hely a bufferbe
        NumNeed := NeedBytes div SizeOf(TEnumServiceStatus) + 1;
        SetLength(Buffer,NumNeed);

        // Most mr tnyleg lekrjk a _teljes_ listt
        if EnumServicesStatus(scHandle,SERVICE_WIN32,SERVICE_STATE_ALL,Buffer[0],SizeOf(TEnumServiceStatus) * numneed,NeedBytes,Ret,Resume) then
          begin
            // Ha vgeztnk, listzzuk az eredmnyt
            for i := low(buffer) to ret - 1 do
              if Assigned(buffer[i].lpServiceName) then
                ListBox1.Items.Add(buffer[i].lpServiceName);
          end
          else
            MessageDlg(SysErrorMessage(GetLastError),mtError,[mbOK],0);
      end
      else
        if not Success then
          MessageDlg(SysErrorMessage(ErrorCode),mtError,[mbOK],0);
  finally
    if not CloseServiceHandle(scHandle) then
      MessageDlg(SysErrorMessage(GetLastError),mtError,[mbOK],0);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  scHandle : SC_HANDLE;
  Service : SC_Handle;

  NeedBytes, ErrorCode : Cardinal;
  Buffer : PQueryServiceConfig;
begin
  if ListBox1.ItemIndex = -1 then
    exit;
    
  scHandle := OpenSCManager('',nil,SC_MANAGER_ALL_ACCESS);
  if scHandle = 0 then
    begin
      MessageDlg(SysErrorMessage(GetLastError),mtError,[mbOK],0);
      exit;
    end;

  try
    Service := OpenService(scHandle,PChar(ListBox1.Items[ListBox1.ItemIndex]),SERVICE_QUERY_CONFIG);
    if Service = 0 then
      begin
        MessageDlg(SysErrorMessage(GetLastError),mtError,[mbOK],0);
        exit;
      end;

    try
      Buffer := nil;
      if not QueryServiceConfig(Service,nil,0,NeedBytes) then
        begin
          ErrorCode := GetLastError;
          if ErrorCode = ERROR_INSUFFICIENT_BUFFER then
            begin
              GetMem(Buffer,NeedBytes + 1);

              if not QueryServiceConfig(Service,Buffer,NeedBytes,NeedBytes) then
                begin
                  MessageDlg(SysErrorMessage(GetLastError),mtError,[mbOK],0);
                  exit;
                end;
            end
            else
            begin
              MessageDlg(SysErrorMessage(ErrorCode),mtError,[mbOK],0);
              exit;
            end;
        end;

      with Buffer^ do
        begin
          case dwServiceType of
            SERVICE_FILE_SYSTEM_DRIVER : SrvType.Caption := 'Fjlrendszer meghajt';
            SERVICE_KERNEL_DRIVER: SrvType.Caption := 'Egyb meghajt';
            SERVICE_WIN32_OWN_PROCESS: SrvType.Caption := 'Win32 sajt folyamatban fut';
            SERVICE_WIN32_SHARE_PROCESS: SrvType.Caption := 'Win32 megosztott folyamatban fut';
          end;

          case dwStartType of
            SERVICE_AUTO_START : SrvStart.Caption := 'Automatikus';
            SERVICE_BOOT_START: SrvStart.Caption := 'Rendszer betltskor';
            SERVICE_DEMAND_START: SrvStart.Caption := 'Kzi';
            SERVICE_DISABLED: SrvStart.Caption := 'Letiltva';
            SERVICE_SYSTEM_START: SrvStart.Caption := 'Rendszer indulskor';
          end;

          case dwErrorControl of
            SERVICE_ERROR_IGNORE: ErrorCtrl.Caption := 'Ignore';
            SERVICE_ERROR_NORMAL: ErrorCtrl.Caption := 'Normal';
            SERVICE_ERROR_SEVERE: ErrorCtrl.Caption := 'Severe';
            SERVICE_ERROR_CRITICAL: ErrorCtrl.Caption := 'Critical';
          end;

          BinPath.Caption := lpBinaryPathName;
          GroupName.Caption := lpLoadOrderGroup;
          GroupID.Caption := IntToStr(dwTagId);
          AccountName.Caption := lpServiceStartName;
          DispName.Caption := lpDisplayName;

          ListBox2.Items.Clear;

          while (lpDependencies[1] <> #0) do
            begin
              if (lpDependencies[0] = #0) and (lpDependencies[1] <> #0) then
                lpDependencies := lpDependencies + 1;
              ListBox2.Items.Add(StrPas(lpDependencies));
              lpDependencies := lpDependencies + StrLen(lpDependencies);
            end;
        end;
    finally
      if not CloseServiceHandle(Service) then
        MessageDlg(SysErrorMessage(GetLastError),mtError,[mbOK],0);
    end;
  finally
    if not CloseServiceHandle(scHandle) then
      MessageDlg(SysErrorMessage(GetLastError),mtError,[mbOK],0);
  end;
end;

end.
